﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MainApp.Controls
{
	public partial class DataSet_Merge_Control : UserControl
	{
		public DataSet_Merge_Control()
		{
			InitializeComponent();

			InitInstance();
		}

		private void InitInstance()
		{
			if (!AdoClient.Instance.SetConnection("peacecloud.synology.me,21433", "Study", "study", "Study123$"))
			{
				MessageBox.Show("Cannot access database.");
				return;
			}

			DoWork();
		}

		private void BindTableToGridView(DataGridView gridView, DataTable table)
		{
			gridView.SuspendLayout();
			gridView.DataSource = table;
			gridView.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
			gridView.ResumeLayout();
		}

		private void DoWork()
		{
			DataSet dataSet_before = AdoClient.Instance.Query("SELECT * FROM EMPLOYEE");

			Random rnd = new Random();
			int[] idxArr = new int[3]
			{
				rnd.Next(1000, 2000),
				rnd.Next(1000, 2000),
				rnd.Next(1000, 2000)
			};

			foreach (int idx in idxArr)
			{
				AdoClient.Instance.NonQuery($"INSERT INTO EMPLOYEE (ENO, ENAME, JOB, HIREDATE) VALUES ({idx}, 'e{idx}', 'processed', '{DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss")}')");
			}

			AdoClient.Instance.NonQuery($"DELETE FROM EMPLOYEE WHERE ENO = {idxArr[1]}");

			DataSet dataSet_after = AdoClient.Instance.Query("SELECT * FROM EMPLOYEE");

			dataSet_before.Merge(dataSet_after); // 동일한 구조의 테이블이라면 변경된 레코드 모두 반영됨

			BindTableToGridView(topGridView, dataSet_before.Tables[0]);
			BindTableToGridView(bottomGridView, dataSet_after.Tables[0]);
		}
	}
}
